// TidyScreen Module
// $Author: Jeffrey J Weimer$
// SVN History: $Revision: 1067 $ on $Date: 2009-06-29 08:34:54 -0700 (Mon, 29 Jun 2009) $
//
// See the Help file for further information

#pragma rtGlobals=1
#pragma IgorVersion=6.10
#pragma version=1.1

#define NOTEST		// comment out these two lines to do development
#pragma IndependentModule=TidyScreen
//#pragma ModuleName=TidyScreen

#pragma hide=1

#include "ScreenSizer", version>=2.2

#define English

Static StrConstant thePackage="TidyScreen"
Static StrConstant thePackageFolder=""
Static StrConstant theProcedureFile = "TidyScreen.ipf"
Static Constant thePackageVersion = 1.1
Static Constant hasHelp = 1

#ifdef English
Static StrConstant KillMeRequest="Do you really want to remove TidyScreen?"
#endif
#ifdef Deutsch
Static StrConstant KillMeRequest="Moechten Sie verchlich TidyScreen abloeschen?"
#endif

// Package Constants

// Menu

Menu "Misc"
	Submenu "Panels"
		"Tidy Screen", MakeTidyScreenPanel()
	end
end

// Tidy Screen Panel

Function MakeTidyScreenPanel()

	if (WinType("TidyScreen")==7)
		DoWindow/F TidyScreen
		return 0
	endif
	
#ifdef NOTEST
	string GIMN = GetIndependentModuleName()
	string theCmd = ""
	sprintf theCmd "%s#ScreenSizer#Initialize(0)", GIMN
	Execute/Z/Q theCmd	
#else
	ScreenSizer#Initialize(0)
#endif
	
	string title = "TidyScreen"

	NewPanel/W=(35,50,200,155)/N=TidyScreen/K=1 as title
#ifdef NOTEST
	ModifyPanel/W=TidyScreen noEdit=1,fixedSize=1
	sprintf theCmd "%s#ScreenSizer#ShiftAWindow(-10,10,\"TidyScreen\")", GIMN
	Execute/Z/Q theCmd
#else
	ScreenSizer#ShiftAWindow(-10,10,"TidyScreen")
#endif

	// reset the panel to the Default desktop rather than the current desktop

	Execute/Z/Q "ACL_WindowDesktops#SetWindowDesktop(\"TidyScreen\",0)"

	// the NOT checkbox
	
	CheckBox not,pos={6,9},size={25,14},title="!"
	CheckBox not,help={"Check this to have the inverse applied to your selection of what windows to change"}
	CheckBox not,font="Courier",fSize=12,value= 0
	
	// what windows?
	
	PopupMenu What,pos={35,6},size={120,20},title=""
	PopupMenu What,help={"Select which kinds of windows to change"},font="Courier"
	PopupMenu What,fSize=12
	PopupMenu What,mode=1,popvalue="Graphs",value= #"\"Graphs;Tables;Layouts;Notebooks;\\M1(Panels;Procedures;XOPS;\""
	
	// front window selector
	
	CheckBox front,pos={10,27},size={54,14},title="Front",proc=DoFrontOnly
	CheckBox front,help={"Check this to operate only on the frontmost window"}
	CheckBox front,font="Courier",fSize=12,value= 0

	// margin
	
	SetVariable margin title="||",pos={109,52},size={45,20},limits={0,10,1},value= _NUM:0, proc=SetMargin
	
	// do it
	
	Button DoIt,pos={6,43},size={20,20},title="->",proc=DoIt
	Button DoIt,help={"Click this button to complete the task"},font="Courier"

	// procedure
	
	PopupMenu Task,pos={35,43},size={90,20},title="",proc=SelectTask
	PopupMenu Task,help={"Select the option to move or size windows"},font="Courier"
	PopupMenu Task,fSize=12,mode=1,popvalue="Move",value= #"\"Move;Size;Shift;\""

	// the version number
	
	sprintf theCmd, "v %g", thePackageVersion
	SetDrawLayer UserBack
	SetDrawEnv fsize= 9
	DrawText 110,40, theCmd
	
	// Help
	
	Button GetHelp,pos={140,5},size={20,20},title="?",proc=GetHelp
	Button GetHelp,help={"Click this button to open the help file"},font="Courier"
	
	// remove me
	
	Button removeme,pos={140,28},size={20,20},title="X",proc=RemoveThis
	Button removeme,help={"Click this button to remove the TidyScreen package from this experiment"},font="Courier"
	
	// values
	
	SetVariable top,pos={12,68},size={70,15},title="V",help={"top size (%)"}
	SetVariable top,font="Arial",fSize=12,limits={0,100,5},value= _NUM:0
	SetVariable left,pos={12,84},size={70,15},title=">",help={"left size (%)"}
	SetVariable left,font="Arial",fSize=12,limits={0,100,5},value= _NUM:0
	SetVariable right,pos={84,68},size={70,15},title=">",help={"right size (%)"}
	SetVariable right,font="Arial",fSize=12,limits={0,100,5},value= _NUM:0
	SetVariable bottom,pos={84,84},size={70,15},title="V",help={"bottom size (%)"}
	SetVariable bottom,font="Arial",fSize=12,limits={0,100,5},value= _NUM:0

	return 0
	
End

Function SelectTask(pa) : PopupMenuControl
	STRUCT WMPopupAction &pa

	switch( pa.eventCode )
		case 2:
			strswitch(pa.popStr)
				case "Move":
					SetVariable top, title="V",help={"top size (%)"}, limits={0,100,5},value= _NUM:0
					SetVariable left,title=">",help={"left size (%)"},limits={0,100,5},value= _NUM:0
					SetVariable right,title=">",font="Arial",help={"right size (%)"},limits={0,100,5}, disable=0 //,value= _NUM:0
					SetVariable bottom,title="V",font="Arial",help={"bottom size (%)"},limits={0,100,5},disable=0 //,value= _NUM:0
					ControlInfo What
					if (V_value==5)
						PopupMenu What,mode=1,popvalue="Graphs",value= #"\"Graphs;Tables;Layouts;Notebooks;\\M1(Panels;Procedures;XOPS;\""
					else
						PopupMenu What,mode=V_value,popvalue=S_value,value= #"\"Graphs;Tables;Layouts;Notebooks;\\M1(Panels;Procedures;XOPS;\""
					endif
					break
				case "Size":
					SetVariable top, title="|",help={"top size (%)"}, limits={0,100,5},value= _NUM:0
					SetVariable left,title="_",help={"left size (%)"},limits={0,100,5},value= _NUM:0
					SetVariable right, disable = 1
					SetVariable bottom, disable = 1
					ControlInfo What
					if (V_value==5)
						PopupMenu What,mode=1,popvalue="Graphs",value= #"\"Graphs;Tables;Layouts;Notebooks;\\M1(Panels;Procedures;XOPS;\""
					else
						PopupMenu What,mode=V_value,popvalue=S_value,value= #"\"Graphs;Tables;Layouts;Notebooks;\\M1(Panels;Procedures;XOPS;\""
					endif
					break
				case "Shift":
					ControlInfo front
					SetVariable top, title="V",help={"top size (%)"}, limits={-100,100,5} //,value= _NUM:0
					SetVariable left,title=">",help={"left size (%)"},limits={-100,100,5} //,value= _NUM:0
					SetVariable right,title="D",font="Symbol",help={"left-to-right offset (%)"},limits={-100,100,5}, disable=(V_value)
					SetVariable bottom,title="D",font="Symbol",help={"top-to-bottom offset (%)"},limits={-100,100,5}, disable=(V_value)			
					ControlInfo What
					PopupMenu What,mode=V_value,popvalue=S_value,value= #"\"Graphs;Tables;Layouts;Notebooks;Panels;Procedures;XOPS;\""
					break
			endswitch
	endswitch

	return 0
End

Function DoFrontOnly(cba) : CheckBoxControl
	STRUCT WMCheckboxAction &cba

	switch( cba.eventCode )
		case 2: // mouse up
			PopupMenu What, disable=(cba.checked)
			CheckBox not, disable=(cba.checked)
			ControlInfo Task
			strswitch(S_Value)
				case "Move":
				case "Size":
					SetVariable right,disable=0
					SetVariable bottom,disable=0
					break
				case "Shift":
					SetVariable right,disable=(cba.checked)
					SetVariable bottom,disable=(cba.checked)
					break
			endswitch
			break
	endswitch

	return 0
End

Function DoIt(ba) : ButtonControl
	STRUCT WMButtonAction &ba

	switch( ba.eventCode )
		case 2: // mouse up
			variable left, top, right, bottom, type, task, front
			string theKind="", theTask="", theCmd=""
			
			ControlInfo front
			if (V_value)
				front = 1
				theKind = ""
			else
				front = 0
				ControlInfo What
				theKind = S_value			
			endif

			ControlInfo Task
			theTask = S_value
			task = V_value
			if (!front)
				ControlInfo not
				if (V_value)
					strswitch(theKind)
						case "Graphs":
							type = (2+4+16+128+4096)
							type += (task==3)*64
							break
						case "Tables":
							type = (1+4+16+128+4096)
							type += (task==3)*64
							break
						case "Layouts":
							type = (1+2+16+128+4096)
							type += (task==3)*64
							break
						case "Notebooks":
							type = (1+2+4+128+4096)
							type += (task==3)*64
							break
						case "Panels":
							type = (1+2+4+16+128+4096)
							break
						case "Procedures":
							type = (1+2+4+16+4096)
							type += (task==3)*64
							break
						case "XOPs":
							type = (1+2+4+16+128)
							type += (task==3)*64
							break
					endswitch
				else
					strswitch(theKind)
						case "Graphs":
							type = 1
							break
						case "Tables":
							type = 2
							break
						case "Layouts":
							type = 4
							break
						case "Notebooks":
							type = 16
							break
						case "Panels":
							type = 64
							break
						case "Procedures":
							type = 128
							break
						case "XOPs":
							type = 4096
							break
					endswitch
				endif
			else
				theKind=WinName(1,(1+2+4+16+64+128+4096))
				type = WinType(theKind)
				switch(type)
					case 0: // procedure
						type = 128
						theKind = WinName(0,type)
						break
					case 7: // panel
						if (cmpstr(theTask,"Shift")!=0)
							return 0
						endif
					default:
						theKind = WinName(0,type)
						break
				endswitch
			endif

			ControlInfo left
			left = V_value
			ControlInfo right
			right = V_value
			ControlInfo top
			top = V_value
			ControlInfo bottom
			bottom = V_value
			
#ifdef NOTEST
			string GIMN = GetIndependentModuleName()
#endif

			strswitch(theTask)
				case "Move":					
#ifdef NOTEST
					if (front)
						sprintf theCmd, "%s#ScreenSizer#MoveAWindow(%d,%d,%d,%d,%s)", GIMN,left,top,right,bottom,theKind
					else
						sprintf theCmd, "%s#ScreenSizer#MoveWindows(%d,%d,%d,%d,type=%d)", GIMN, left,top,right,bottom,type
					endif
					Execute/Q/Z theCmd					
#else
					if (front)
						ScreenSizer#MoveAWindow(left,top,right,bottom,theKind)
					else
						ScreenSizer#MoveWindows(left,top,right,bottom,type=type)
					endif
#endif
					break
				case "Size":
#ifdef NOTEST
					if (front)
						sprintf theCmd, "%s#ScreenSizer#SizeAWindow(%d,%d,%s)", GIMN,left,top,theKind
					else
						sprintf theCmd, "%s#ScreenSizer#SizeWindows(%d,%d,type=%d)", GIMN, left,top,type
					endif
					Execute/Q/Z theCmd					
#else
					if (front)
						ScreenSizer#SizeAWindow(left,top,theKind)
					else
						ScreenSizer#SizeWindows(left,top,type=type)
					endif
#endif
					break
				case "Shift":
#ifdef NOTEST
					if (front)
						sprintf theCmd, "%s#ScreenSizer#ShiftAWindow(%d,%d,%s)", GIMN,left,top,theKind
					else
						sprintf theCmd, "%s#ScreenSizer#ShiftWindows(%d,%d,type=%d,dlr=%d,dtb=%d,exclude=\"TidyScreen;\")", GIMN, left,top,type,bottom,right
					endif
					Execute/Q/Z theCmd					
#else
					if (front)
						ScreenSizer#ShiftAWindow(left,top,theKind)
					else
						ScreenSizer#ShiftWindows(left,top,type=type,dlr=bottom,dtb=right,exclude="TidyScreen;")
					endif
#endif
					break
			endswitch
			break
			return 0
			break
	endswitch

	return 0
End

Function SetMargin(sva) : SetVariableControl
	STRUCT WMSetVariableAction &sva

	switch( sva.eventCode )
		case 1: // mouse up
		case 2: // Enter key
		case 3: // Live update
#ifdef NOTEST
			string GIMN = GetIndependentModuleName()
			string theCmd
			sprintf theCmd "%s#ScreenSizer#SetFrame(%d,%d,%d,%d)", GIMN,sva.dval, sva.dval,(100-sva.dval),(100-sva.dval)
			Execute/Q/Z theCmd
#else
			ScreenSizer#SetFrame(sva.dval,sva.dval,100-sva.dval,100-sva.dval)
#endif
			break
	endswitch

	return 0
End

Function GetHelp(ba) : ButtonControl
	STRUCT WMButtonAction &ba

	switch( ba.eventCode )
		case 2: // mouse up
			Help()
			break
	endswitch

	return 0
End

Function RemoveThis(ba) : ButtonControl
	STRUCT WMButtonAction &ba

	switch( ba.eventCode )
		case 2: // mouse up
			KillWindow TidyScreen
			RemoveMe()
			break
	endswitch

	return 0
End

// Help Static Function

Static Function Help()

	if (!hasHelp)
		DoAlert 0, "NO HELP FOR THIS PACKAGE!"
		return 0
	endif

	if (strlen(thePackage)!=0)
		DisplayHelpTopic thePackage
	else
		DoAlert 0, "NO PACKAGE NAME FOR HELP!"
		return -1
	endif
	return 0
end

// Remove Me

Static Function RemoveMe([quiet])
	variable quiet
	
	if (ParamIsDefault(quiet) || (quiet == 0))
		DoAlert 1, KillMeRequest	
		if (V_flag == 2)
			return 0
		endif
	endif
	
	if (strlen(thePackageFolder)!=0)
		KillDataFolder/Z $thePackageFolder
	endif
	
	string theCmd
	if (strlen(thePackage)!=0)
		sprintf theCmd "DELETEINCLUDE \"%s\"" thePackage
		Execute/P/Z/Q theCmd
	endif
	if (strlen(theProcedureFile)!=0)
		sprintf theCmd "CloseProc/NAME=\"%s\"" theProcedureFile	
		Execute/P/Q theCmd
	endif
	
	return 0
end